﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Collections.ObjectModel;
using System.Collections.Specialized;
using Telerik.Windows.Controls;

namespace SelfReferencingData
{
	class DataItemCollection : ObservableCollection<DataItem>
	{
		public DataItemCollection()
		{
			Add(new DataItem() { Text = "Item 1", Id = 1, ParentId = 0, RemoveCommand = new DelegateCommand((p) => { this.RemoveItem(p); }), AddCommand = new DelegateCommand((p) => { this.AddItem(p); }) });
			Add(new DataItem() { Text = "Item 2", Id = 2, ParentId = 0, RemoveCommand = new DelegateCommand((p) => { this.RemoveItem(p); }), AddCommand = new DelegateCommand((p) => { this.AddItem(p); }) });
			Add(new DataItem() { Text = "Item 3", Id = 3, ParentId = 0, RemoveCommand = new DelegateCommand((p) => { this.RemoveItem(p); }), AddCommand = new DelegateCommand((p) => { this.AddItem(p); }) });
			Add(new DataItem() { Text = "Item 1.1", Id = 4, ParentId = 1, RemoveCommand = new DelegateCommand((p) => { this.RemoveItem(p); }), AddCommand = new DelegateCommand((p) => { this.AddItem(p); }) });
			Add(new DataItem() { Text = "Item 1.2", Id = 5, ParentId = 1, RemoveCommand = new DelegateCommand((p) => { this.RemoveItem(p); }), AddCommand = new DelegateCommand((p) => { this.AddItem(p); }) });
			Add(new DataItem() { Text = "Item 1.3", Id = 6, ParentId = 1, RemoveCommand = new DelegateCommand((p) => { this.RemoveItem(p); }), AddCommand = new DelegateCommand((p) => { this.AddItem(p); }) });
			Add(new DataItem() { Text = "Item 2.1", Id = 7, ParentId = 2, RemoveCommand = new DelegateCommand((p) => { this.RemoveItem(p); }), AddCommand = new DelegateCommand((p) => { this.AddItem(p); }) });
			Add(new DataItem() { Text = "Item 2.2", Id = 8, ParentId = 2, RemoveCommand = new DelegateCommand((p) => { this.RemoveItem(p); }), AddCommand = new DelegateCommand((p) => { this.AddItem(p); }) });
			Add(new DataItem() { Text = "Item 2.3", Id = 9, ParentId = 2, RemoveCommand = new DelegateCommand((p) => { this.RemoveItem(p); }), AddCommand = new DelegateCommand((p) => { this.AddItem(p); }) });
			Add(new DataItem() { Text = "Item 3.1", Id = 10, ParentId = 3, RemoveCommand = new DelegateCommand((p) => { this.RemoveItem(p); }), AddCommand = new DelegateCommand((p) => { this.AddItem(p); }) });
			Add(new DataItem() { Text = "Item 3.2", Id = 11, ParentId = 3, RemoveCommand = new DelegateCommand((p) => { this.RemoveItem(p); }), AddCommand = new DelegateCommand((p) => { this.AddItem(p); }) });
			Add(new DataItem() { Text = "Item 3.3", Id = 12, ParentId = 3, RemoveCommand = new DelegateCommand((p) => { this.RemoveItem(p); }), AddCommand = new DelegateCommand((p) => { this.AddItem(p); }) });
		}

		public void RemoveItem(object param)
		{
			DataItem item = param as DataItem;
			if (item.ParentId == 0)
				this.Remove(item);
			else
			{
				this.Where(i => i.Id == item.ParentId).FirstOrDefault().Children.Remove(item);
			}

		}

		public void AddItem(object param)
		{
			(param as DataItem).Children.Add(new DataItem() { Text = "NewItem", ParentId = (param as DataItem).Id, Id = 111, RemoveCommand = new DelegateCommand((p) => { this.RemoveItem(p); }), AddCommand = new DelegateCommand((p) => { this.AddItem(p); }) });
		}

		protected override void InsertItem(int index, DataItem item)
		{
			this.AdoptItem(item);
			base.InsertItem(index, item);
		}
		protected override void RemoveItem(int index)
		{
			this.DiscardItem(this[index]);
			base.RemoveItem(index);
		}
		protected override void SetItem(int index, DataItem item)
		{
			this.AdoptItem(item);
			base.SetItem(index, item);
		}
		protected override void ClearItems()
		{
			foreach (DataItem item in this)
			{
				this.DiscardItem(item);
			}
			base.ClearItems();
		}
		private void AdoptItem(DataItem item)
		{
			item.SetOwner(this);
		}
		private void DiscardItem(DataItem item)
		{
			item.SetOwner(null);
			item.SetChildren(null);
		}
	}
}
