﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Data;
using System.Globalization;
using System.Collections.ObjectModel;

namespace SelfReferencingData
{
	class HierarchyConverter : IValueConverter
	{
		public object Convert(object value, Type targetType, object parameter, CultureInfo culture)
		{
			// We are binding an item
			DataItem item = value as DataItem;
			if (item != null)
			{
				if (item.Children.Count == 0 && item.Owner!= null)
					item.SetChildren(new ObservableCollection<DataItem>(item.Owner.Where(i => i.ParentId == item.Id)));
				return item.Children;
			}
			// We are binding the treeview
			DataItemCollection items = value as DataItemCollection;
			if (items != null)
			{
				return new ObservableCollection<DataItem>(items.Where(i => i.ParentId == 0));
			}
			return null;
		}
		public object ConvertBack(object value, Type targetType, object parameter, CultureInfo culture)
		{
			throw new NotImplementedException();
		}
	}
}
